
package org.mule.modules.workday.staffing.config.spring;

import java.util.List;
import org.apache.commons.lang.StringUtils;
import org.mule.config.spring.MuleHierarchicalBeanDefinitionParserDelegate;
import org.mule.config.spring.util.SpringXMLUtils;
import org.mule.modules.workday.staffing.config.GetMantainEmployeeContractsMessageProcessor;
import org.mule.util.TemplateParser;
import org.springframework.beans.MutablePropertyValues;
import org.springframework.beans.PropertyValue;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.beans.factory.config.RuntimeBeanReference;
import org.springframework.beans.factory.support.BeanDefinitionBuilder;
import org.springframework.beans.factory.support.ManagedList;
import org.springframework.beans.factory.support.ManagedMap;
import org.springframework.beans.factory.xml.BeanDefinitionParser;
import org.springframework.beans.factory.xml.ParserContext;
import org.springframework.util.xml.DomUtils;
import org.w3c.dom.Element;

public class GetMantainEmployeeContractsDefinitionParser
    implements BeanDefinitionParser
{

    /**
     * Mule Pattern Info
     * 
     */
    private TemplateParser.PatternInfo patternInfo;

    public GetMantainEmployeeContractsDefinitionParser() {
        patternInfo = TemplateParser.createMuleStyleParser().getStyle();
    }

    public BeanDefinition parse(Element element, ParserContext parserContent) {
        BeanDefinitionBuilder builder = BeanDefinitionBuilder.rootBeanDefinition(GetMantainEmployeeContractsMessageProcessor.class.getName());
        String configRef = element.getAttribute("config-ref");
        if ((configRef!= null)&&(!StringUtils.isBlank(configRef))) {
            builder.addPropertyValue("moduleObject", configRef);
        }
        Element employeeReferenceListElement = null;
        employeeReferenceListElement = DomUtils.getChildElementByTagName(element, "employee-reference");
        List<Element> employeeReferenceListChilds = null;
        if (employeeReferenceListElement!= null) {
            String employeeReferenceRef = employeeReferenceListElement.getAttribute("ref");
            if ((employeeReferenceRef!= null)&&(!StringUtils.isBlank(employeeReferenceRef))) {
                if ((!employeeReferenceRef.startsWith(patternInfo.getPrefix()))&&(!employeeReferenceRef.endsWith(patternInfo.getSuffix()))) {
                    builder.addPropertyValue("employeeReference", new RuntimeBeanReference(employeeReferenceRef));
                } else {
                    builder.addPropertyValue("employeeReference", employeeReferenceRef);
                }
            } else {
                ManagedList employeeReference = new ManagedList();
                employeeReferenceListChilds = DomUtils.getChildElementsByTagName(employeeReferenceListElement, "employee-reference");
                if (employeeReferenceListChilds!= null) {
                    for (Element employeeReferenceChild: employeeReferenceListChilds) {
                        String valueRef = employeeReferenceChild.getAttribute("value-ref");
                        if ((valueRef!= null)&&(!StringUtils.isBlank(valueRef))) {
                            employeeReference.add(new RuntimeBeanReference(valueRef));
                        } else {
                            List<Element> inneremployeereferenceListChilds = null;
                            if (employeeReferenceChild!= null) {
                                String inneremployeereferenceRef = employeeReferenceChild.getAttribute("ref");
                                if ((inneremployeereferenceRef!= null)&&(!StringUtils.isBlank(inneremployeereferenceRef))) {
                                    if ((!inneremployeereferenceRef.startsWith(patternInfo.getPrefix()))&&(!inneremployeereferenceRef.endsWith(patternInfo.getSuffix()))) {
                                        builder.addPropertyValue("inner-employee-reference", new RuntimeBeanReference(inneremployeereferenceRef));
                                    } else {
                                        builder.addPropertyValue("inner-employee-reference", inneremployeereferenceRef);
                                    }
                                } else {
                                    ManagedMap inneremployeereference = new ManagedMap();
                                    inneremployeereferenceListChilds = DomUtils.getChildElementsByTagName(employeeReferenceChild, "inner-employee-reference");
                                    if (inneremployeereferenceListChilds!= null) {
                                        if (inneremployeereferenceListChilds.size() == 0) {
                                            inneremployeereferenceListChilds = DomUtils.getChildElements(employeeReferenceChild);
                                        }
                                        for (Element inneremployeereferenceChild: inneremployeereferenceListChilds) {
                                            String inneremployeereferenceValueRef = inneremployeereferenceChild.getAttribute("value-ref");
                                            String inneremployeereferenceKeyRef = inneremployeereferenceChild.getAttribute("key-ref");
                                            Object valueObject = null;
                                            Object keyObject = null;
                                            if ((inneremployeereferenceValueRef!= null)&&(!StringUtils.isBlank(inneremployeereferenceValueRef))) {
                                                valueObject = new RuntimeBeanReference(inneremployeereferenceValueRef);
                                            } else {
                                                valueObject = inneremployeereferenceChild.getTextContent();
                                            }
                                            if ((inneremployeereferenceKeyRef!= null)&&(!StringUtils.isBlank(inneremployeereferenceKeyRef))) {
                                                keyObject = new RuntimeBeanReference(inneremployeereferenceKeyRef);
                                            } else {
                                                keyObject = inneremployeereferenceChild.getAttribute("key");
                                            }
                                            if ((keyObject == null)||((keyObject instanceof String)&&StringUtils.isBlank(((String) keyObject)))) {
                                                keyObject = inneremployeereferenceChild.getTagName();
                                            }
                                            inneremployeereference.put(keyObject, valueObject);
                                        }
                                    }
                                    employeeReference.add(inneremployeereference);
                                }
                            }
                        }
                    }
                }
                builder.addPropertyValue("employeeReference", employeeReference);
            }
        }
        Element responseFilterTypeListElement = null;
        responseFilterTypeListElement = DomUtils.getChildElementByTagName(element, "response-filter-type");
        List<Element> responseFilterTypeListChilds = null;
        if (responseFilterTypeListElement!= null) {
            String responseFilterTypeRef = responseFilterTypeListElement.getAttribute("ref");
            if ((responseFilterTypeRef!= null)&&(!StringUtils.isBlank(responseFilterTypeRef))) {
                if ((!responseFilterTypeRef.startsWith(patternInfo.getPrefix()))&&(!responseFilterTypeRef.endsWith(patternInfo.getSuffix()))) {
                    builder.addPropertyValue("responseFilterType", new RuntimeBeanReference(responseFilterTypeRef));
                } else {
                    builder.addPropertyValue("responseFilterType", responseFilterTypeRef);
                }
            } else {
                ManagedMap responseFilterType = new ManagedMap();
                responseFilterTypeListChilds = DomUtils.getChildElementsByTagName(responseFilterTypeListElement, "response-filter-type");
                if (responseFilterTypeListChilds!= null) {
                    if (responseFilterTypeListChilds.size() == 0) {
                        responseFilterTypeListChilds = DomUtils.getChildElements(responseFilterTypeListElement);
                    }
                    for (Element responseFilterTypeChild: responseFilterTypeListChilds) {
                        String responseFilterTypeValueRef = responseFilterTypeChild.getAttribute("value-ref");
                        String responseFilterTypeKeyRef = responseFilterTypeChild.getAttribute("key-ref");
                        Object valueObject = null;
                        Object keyObject = null;
                        if ((responseFilterTypeValueRef!= null)&&(!StringUtils.isBlank(responseFilterTypeValueRef))) {
                            valueObject = new RuntimeBeanReference(responseFilterTypeValueRef);
                        } else {
                            valueObject = responseFilterTypeChild.getTextContent();
                        }
                        if ((responseFilterTypeKeyRef!= null)&&(!StringUtils.isBlank(responseFilterTypeKeyRef))) {
                            keyObject = new RuntimeBeanReference(responseFilterTypeKeyRef);
                        } else {
                            keyObject = responseFilterTypeChild.getAttribute("key");
                        }
                        if ((keyObject == null)||((keyObject instanceof String)&&StringUtils.isBlank(((String) keyObject)))) {
                            keyObject = responseFilterTypeChild.getTagName();
                        }
                        responseFilterType.put(keyObject, valueObject);
                    }
                }
                builder.addPropertyValue("responseFilterType", responseFilterType);
            }
        }
        BeanDefinition definition = builder.getBeanDefinition();
        definition.setAttribute(MuleHierarchicalBeanDefinitionParserDelegate.MULE_NO_RECURSE, Boolean.TRUE);
        MutablePropertyValues propertyValues = parserContent.getContainingBeanDefinition().getPropertyValues();
        if (parserContent.getContainingBeanDefinition().getBeanClassName().equals("org.mule.config.spring.factories.PollingMessageSourceFactoryBean")) {
            propertyValues.addPropertyValue("messageProcessor", definition);
        } else {
            PropertyValue messageProcessors = propertyValues.getPropertyValue("messageProcessors");
            if ((messageProcessors == null)||(messageProcessors.getValue() == null)) {
                propertyValues.addPropertyValue("messageProcessors", new ManagedList());
            }
            List listMessageProcessors = ((List) propertyValues.getPropertyValue("messageProcessors").getValue());
            listMessageProcessors.add(definition);
        }
        return definition;
    }

    protected String getAttributeValue(Element element, String attributeName) {
        if (!StringUtils.isEmpty(element.getAttribute(attributeName))) {
            return element.getAttribute(attributeName);
        }
        return null;
    }

    private String generateChildBeanName(Element element) {
        String id = SpringXMLUtils.getNameOrId(element);
        if (StringUtils.isBlank(id)) {
            String parentId = SpringXMLUtils.getNameOrId(((Element) element.getParentNode()));
            return ((("."+ parentId)+":")+ element.getLocalName());
        } else {
            return id;
        }
    }

}
